@use crate::Page;

@(props: &Page, content: Content)

<!doctype html>
<html lang=en prefix="og:http://ogp.me/ns#">
    <meta charset="utf-8">
    <meta name=viewport content="width=device-width,initial-scale=1,shrink-to-fit=no">
    <meta name=color-scheme value="light dark">
    <title>@props.title // Lib.rs</title>
    <meta name="twitter:title" content="@props.title">

    <link crossorigin=anonymous rel=preload as=font href="/fira/va9B4kDNxMZdWfMOD5VnLK3eRhf6Xl7Glw.woff2">
    <link crossorigin=anonymous rel=preload as=font href="/fira/va9B4kDNxMZdWfMOD5VnPKreRhf6Xl7Glw.woff2">
    <link crossorigin=anonymous rel=preload as=font href="/fira/va9E4kDNxMZdWfMOD5Vvl4jLazX3dA.woff2">
    <link crossorigin=anonymous rel=preload as=style href="/index.css">
    <link crossorigin=anonymous rel=preconnect href="//img.gs">
    @if props.noindex {
      <meta name="robots" content="noindex, follow">
    }

    <style>@props.critical_css()</style>
    @if let Some(l) = props.local_css_data() {<style>@l</style>}
    <link crossorigin=anonymous rel=stylesheet href="/index.css">

    @if let Some((crate_name, kind)) = &props.og_image {
      <meta property="og:image" content="https://lib.rs/og/@(kind)/@(crate_name).png">
      <meta property="og:image:width" content="1200"><meta property="og:image:height" content="627">
      <meta name="twitter:image" content="https://lib.rs/og/t@(kind)/@(crate_name).png">
      <meta name="twitter:card" content="summary_large_image">
    } else {
      <meta property="og:image" content="https://lib.rs/crates-logo.png">
      <meta name="twitter:image" content="https://lib.rs/crates-logo.png">
      <meta name="twitter:card" content="summary">
    }
    <link crossorigin=anonymous rel=apple-touch-icon href="/crates-logo.png" type=image/png sizes=256x256>
    <link crossorigin=anonymous rel=icon href="/favicon.png" type=image/png sizes=32x32 media="(prefers-color-scheme: light)">
    <link crossorigin=anonymous rel=icon href="/favicon-dark.png" type=image/png sizes=32x32 media="(prefers-color-scheme: dark)">
    <link crossorigin=anonymous rel=icon href="/crates-logo.png" type=image/png sizes=256x256>
    <link crossorigin=anonymous rel=icon href="/favicon.png" type=image/png sizes=32x32>
    <link crossorigin=anonymous rel=mask-icon href="/logo.svg">
    <meta name=theme-color content="#aaaaaa">

    @if let Some(ref url) = props.canonical {
      <meta property="og:url" content="@url">
      <meta rel=canonical content="@url">
    }
    @if let Some(ref alt) = props.alternate {
      <link rel=alternate href="@alt" @if let Some(ty) = props.alternate_type { type="@ty" }>
      <link rel="og:see_also" href="@alt">
    }
    @if let Some(ref item_name) = props.item_name {
      <meta property="og:title" content="@item_name">
    }
    @if let Some(ref desc) = props.item_description {
      <meta property="og:description" content="@desc">
    }
    @if let Some(ref desc) = props.description {
      <meta name=description content="@desc">
    }
    @if let Some(ref d) = props.created {
      <meta name="date.created" content="@d">
      <meta name="article:published_time" content="@d">
    }
    @if let Some(ref k) = props.keywords {
      <meta name=keywords content="@k">
    }
    <meta property="og:type" content=@props.og_type.unwrap_or("website")>
    @if let Some(ref u) = props.username {
      <meta name=profile:username content="@u">
    }
    <meta property="og:determiner" content="">
    <meta property="og:site_name" content="Lib.rs">
    @if let Some(cat) = &props.og_section {
      <meta property="og:article:section" content="@cat">
      <meta property="og:article:tag" content="@cat">
    }
    @if let Some(ref a) = props.author {
      <meta name="article:author" content="@a">
    }
    @for handle in &props.fediverse_creators {
      <meta name="fediverse:creator" content="@handle">
    }
    @if props.search_meta {
      <link title="Lib.rs" type="application/opensearchdescription+xml" rel=search href="@props.url_prefix()/opensearch.xml">
    }
  <body vocab="http://schema.org/">
    @:content()
  </body>
</html>
